Index: LMDZ5/branches/testing/libf/phylmd/Dust/lsc_scav_orig.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/lsc_scav_orig.F90	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/lsc_scav_orig.F90	(revision 2641)
@@ -0,0 +1,291 @@
+!$Id $
+
+SUBROUTINE lsc_scav_orig(pdtime,it,iflag_lscav,oliq,flxr,flxs,rneb,beta_fisrt,  &
+                    beta_v1,pplay,paprs,t,tr_seri,d_tr_insc,          &
+                    d_tr_bcscav,d_tr_evap,qPrls) 
+  USE ioipsl
+  USE dimphy
+  USE mod_grid_phy_lmdz
+  USE mod_phys_lmdz_para
+  USE traclmdz_mod
+  USE infotrac,ONLY : nbtr
+!!!  USE geometry_mod
+  USE iophy
+
+  IMPLICIT NONE 
+!=====================================================================
+! Objet : depot humide (lessivage et evaporation) de traceurs
+! Inspired by routines of Olivier Boucher (mars 1998)
+! author R. Pilon 10 octobre 2012
+! last modification 16/01/2013 (reformulation partie evaporation)
+!=====================================================================
+
+  include "dimensions.h"
+  include "chem.h"
+  include "YOMCST.h"
+  include "YOECUMF.h" 
+
+  REAL,INTENT(IN)                        :: pdtime ! time step (s)
+  INTEGER,INTENT(IN)                     :: it     ! tracer number
+  INTEGER,INTENT(IN)                     :: iflag_lscav ! LS scavenging param:
+!                                             3=Reddy_Boucher2004, 4=3+RPilon.
+  REAL,DIMENSION(klon,klev+1),INTENT(IN) :: flxr     ! flux precipitant de pluie
+  REAL,DIMENSION(klon,klev+1),INTENT(IN) :: flxs     ! flux precipitant de neige
+  REAL,INTENT(IN)                        :: oliq ! contenu en eau liquide dans le nuage (kg/kg)
+  REAL,DIMENSION(klon,klev),INTENT(IN)   :: rneb
+  REAL,DIMENSION(klon,klev),INTENT(IN)   :: pplay    ! pression
+  REAL,DIMENSION(klon,klev+1),INTENT(IN) :: paprs    ! pression
+  REAL,DIMENSION(klon,klev),INTENT(IN)   :: t        ! temperature
+! tracers
+  REAL,DIMENSION(klon,klev,nbtr),INTENT(IN)   :: tr_seri        ! q de traceur  
+  REAL,DIMENSION(klon,klev),INTENT(IN)        :: beta_fisrt     ! taux de conversion de l'eau cond
+  REAL,DIMENSION(klon,klev),INTENT(OUT)       :: beta_v1        ! -- (originale version)
+  REAL,DIMENSION(klon)                        :: his_dh         ! tendance de traceur integre verticalement
+  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)  :: d_tr_insc      ! tendance du traceur 
+  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)  :: d_tr_bcscav  ! tendance de traceur
+  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)  :: d_tr_evap
+  REAL,DIMENSION(klon,nbtr),INTENT(OUT)       :: qPrls      !jyg: concentration tra dans pluie LS a la surf.
+  REAL :: dxin,dxev                              ! tendance temporaire de traceur incloud
+  REAL,DIMENSION(klon,klev) :: dxbc       ! tendance temporaire de traceur bc
+
+
+!  variables locales      
+ LOGICAL,SAVE :: debut=.true.
+!$OMP THREADPRIVATE(debut)
+!
+  REAL,PARAMETER :: henry=1.4  ! constante de Henry en mol/l/atm ~1.4 for gases
+  REAL           :: henry_t    !  constante de Henry a T t  (mol/l/atm)
+  REAL,PARAMETER :: kk=2900.   ! coefficient de dependence en T (K)
+  REAL :: f_a     !  rapport de la phase aqueuse a la phase gazeuse
+  REAL :: beta    !  taux de conversion de l'eau en pluie
+
+  INTEGER :: i, k
+  REAL,DIMENSION(klon,klev)    :: scav  !  water liquid content / fraction aqueuse du constituant
+  REAL,DIMENSION(klon,klev)    :: zrho
+  REAL,DIMENSION(klon,klev)    :: zdz
+  REAL,DIMENSION(klon,klev)    :: zmass ! layer mass
+
+  REAL           :: frac_ev       ! cste pour la reevaporation : dropplet shrinking
+!  frac_ev = frac_gas ou frac_aer
+  REAL,PARAMETER :: frac_gas=1.0  ! cste pour la reevaporation pour les gaz
+  REAL           :: frac_aer      ! cste pour la reevaporation pour les particules
+  REAL,DIMENSION(klon,klev) :: deltaP     ! P(i+1)-P(i)
+  REAL,DIMENSION(klon,klev) :: beta_ev    !  dP/P(i+1)
+
+!  101.325  m3/l x Pa/atm
+!  R        Pa.m3/mol/K
+!   cste de dissolution pour le depot humide
+  REAL,SAVE :: frac_fine_scav
+  REAL,SAVE :: frac_coar_scav
+!$OMP THREADPRIVATE(frac_fine_scav, frac_coar_scav)
+
+! below-cloud scav variables
+! aerosol : alpha_r=0.001, gas 0.001  (Pruppacher & Klett 1967)
+  REAL,SAVE :: alpha_r  !  coefficient d'impaction pour la pluie
+  REAL,SAVE :: alpha_s  !  coefficient d'impaction pour la neige  
+  REAL,SAVE :: R_r      !  mean raindrop radius (m) 
+  REAL,SAVE :: R_s      !  mean snow crystal radius (m)
+!$OMP THREADPRIVATE(alpha_r, alpha_s, R_r, R_s)
+  REAL           :: pr, ps, ice, water
+  real :: conserv
+!
+!!!!!!!!!!!!!!!!!!!! choix lessivage !!!!!!!!!!!!!!!!!!!!!!!!
+!!  logical,save  :: inscav_fisrt
+!!! $OMP THREADPRIVATE(inscav_first)
+!
+!!!!!!!!!!!!!!!!!!!!!!!!!!!
+  IF (debut) THEN
+!
+!  inscav_fisrt=.true.
+!  call getin('inscav_fisrt',inscav_fisrt)
+!  if(inscav_fisrt) then 
+!   print*,'beta from fisrtilp.F90, beta = (z_cond - z_oliq)/z_cond, inscav_fisrt=',inscav_fisrt
+!  else
+!   print*,'beta from Reddy and Bocuher 2004 (original version), inscav_fisrt=',inscav_fisrt
+!  endif
+!
+      alpha_r=0.001        !  coefficient d'impaction pour la pluie
+      alpha_s=0.01         !  coefficient d'impaction pour la neige  
+      R_r=0.001            !  mean raindrop radius (m) 
+      R_s=0.001            !  mean snow crystal radius (m)
+      frac_fine_scav=0.7
+      frac_coar_scav=0.7
+!     frac_aer=0.5 ~ droplet size shrinks by evap
+      frac_aer=0.5
+!
+
+!JE to speed up, commented 20140219
+!
+!      OPEN(99,file='lsc_scav_param.data',status='old', &
+!                form='formatted',err=9999)
+!      READ(99,*,end=9998)  alpha_r
+!      READ(99,*,end=9998)  alpha_s
+!      READ(99,*,end=9998)  R_r
+!      READ(99,*,end=9998)  R_s
+!      READ(99,*,end=9998)  frac_fine_scav
+!      READ(99,*,end=9998)  frac_coar_scav
+!      READ(99,*,end=9998)  frac_aer
+!9998  Continue
+!      CLOSE(99)
+!9999  Continue
+!
+!   print*,'alpha_r',alpha_r
+!   print*,'alpha_s',alpha_s
+!   print*,'R_r',R_r
+!   print*,'R_s',R_s
+!   print*,'frac_fine_scav',frac_fine_scav
+!   print*,'frac_coar_scav',frac_coar_scav
+!   print*,'frac_aer ev',frac_aer
+!
+! JE endcomment
+!
+  ENDIF !(debut)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!
+! initialization
+  dxin=0.
+  dxev=0.
+  beta_ev=0.
+
+  DO i=1,klon
+   his_dh(i)=0.
+  ENDDO
+
+  DO k=1,klev
+   DO i=1, klon 
+    dxbc(i,k)=0.
+    beta_v1(i,k)=0.
+    deltaP(i,k)=0.
+   ENDDO
+  ENDDO
+
+  DO k=1,klev
+    DO i=1, klon
+     d_tr_insc(i,k,it)=0.
+     d_tr_bcscav(i,k,it)=0.
+     d_tr_evap(i,k,it)=0.
+    ENDDO
+  ENDDO
+
+!  pressure and size of the layer
+  DO k=klev-1, 1, -1
+   DO i=1, klon 
+     zrho(i,k)=pplay(i,k)/t(i,k)/RD   
+     zdz(i,k)=(paprs(i,k)-paprs(i,k+1))/zrho(i,k)/RG
+     zmass(i,k)=(paprs(i,k)-paprs(i,k+1))/RG
+   ENDDO
+  ENDDO
+
+    IF (it.gt.1) THEN                               !  aerosol   
+      frac_ev=frac_aer
+    ELSE                                                !  gas
+      frac_ev=frac_gas
+    ENDIF
+
+    IF(it.gt.1) then  ! aerosol
+     DO k=1, klev
+      DO i=1, klon 
+       scav(i,k)=frac_fine_scav
+      ENDDO 
+     ENDDO
+    ELSE                  ! gas
+     DO k=1, klev
+      DO i=1, klon 
+       henry_t=henry*exp(-kk*(1./298.-1./t(i,k)))    !  mol/l/atm
+       f_a=henry_t/101.325*R*t(i,k)*oliq*zrho(i,k)/rho_water
+       scav(i,k)=f_a/(1.+f_a)
+      ENDDO 
+     ENDDO
+    ENDIF
+
+   DO k=klev-1, 1, -1
+    DO i=1, klon 
+!  incloud scavenging
+!   if(inscav_fisrt) then 
+   if (iflag_lscav .eq. 4) then
+      beta=beta_fisrt(i,k)*rneb(i,k)
+   else
+      beta=flxr(i,k)-flxr(i,k+1)+flxs(i,k)-flxs(i,k+1)
+!      beta=beta/zdz(i,k)/oliq/zrho(i,k)
+      beta=beta/zmass(i,k)/oliq
+      beta=MAX(0.,beta)
+   endif ! (iflag_lscav .eq. 4)
+   beta_v1(i,k)=beta    !! for output
+!
+      dxin=tr_seri(i,k,it)*(exp(-scav(i,k)*beta*pdtime)-1.)
+!      his_dh(i)=his_dh(i)-dxin*zrho(i,k)*zdz(i,k)/pdtime !  kg/m2/s
+      his_dh(i)=his_dh(i)-dxin*zmass(i,k)/pdtime !  kg/m2/s
+      d_tr_insc(i,k,it)=dxin
+
+!  below-cloud impaction
+    IF(it.eq.1) then
+      d_tr_bcscav(i,k,it)=0.
+    ELSE
+     pr=0.5*(flxr(i,k)+flxr(i,k+1))
+     ps=0.5*(flxs(i,k)+flxs(i,k+1))
+     water=pr*alpha_r/R_r/rho_water
+     ice=ps*alpha_s/R_s/rho_ice
+     dxbc(i,k)=-3./4.*tr_seri(i,k,it)*pdtime*(water+ice)
+!   add tracers from below cloud scav in his_dh
+     his_dh(i)=his_dh(i)-dxbc(i,k)*zmass(i,k)/pdtime !  kg/m2/s
+     d_tr_bcscav(i,k,it)=dxbc(i,k)
+    ENDIF
+
+!  reevaporation
+      deltaP(i,k)=flxr(i,k+1)+flxs(i,k+1)-flxr(i,k)-flxs(i,k)
+      deltaP(i,k)=max(deltaP(i,k),0.)
+
+      if(flxr(i,k+1)+flxs(i,k+1).gt.1.e-16) then
+       beta_ev(i,k)=deltaP(i,k)/(flxr(i,k+1)+flxs(i,k+1))
+      else
+       beta_ev(i,k)=0.
+      endif
+
+      beta_ev(i,k)=max(min(1.,beta_ev(i,k)),0.)
+
+!jyg
+      
+      if(abs(1-(1-frac_ev)*beta_ev(i,k)).gt.1.e-16) then
+! remove tracers from precipitation owing to release by evaporation in his_dh
+!      dxev=frac_ev*beta_ev(i,k)*his_dh(i) *pdtime/(zrho(i,k)*zdz(i,k)) &
+      dxev=frac_ev*beta_ev(i,k)*his_dh(i) *pdtime/(zmass(i,k)) &
+                                      /(1 -(1-frac_ev)*beta_ev(i,k))
+       his_dh(i)=his_dh(i)*(1 - frac_ev*beta_ev(i,k) / (1 -(1-frac_ev)*beta_ev(i,k)))
+      else
+!       dxev=his_dh(i) *pdtime/(zrho(i,k)*zdz(i,k))
+       dxev=his_dh(i) *pdtime/(zmass(i,k))
+       his_dh(i)=0.
+      endif
+!      print*,  k, 'beta_ev',beta_ev
+! remove tracers from precipitation owing to release by evaporation in his_dh
+!!      dxev=frac_ev*deltaP(i,k)*pdtime * his_dh(i) /(zrho(i,k)*zdz(i,k))
+!rplmd
+!!      dxev=frac_ev*deltaP(i,k)*his_dh(i) *pdtime/(zrho(i,k)*zdz(i,k)) &
+!!                                      /max(flxr(i,k)+flxs(i,k),1.e-16)
+
+
+      d_tr_evap(i,k,it)=dxev
+!!     tendency is further added in phytrac x = x + dx
+    ENDDO !!  do i
+   ENDDO  !! do k
+
+!jyg (20130114)
+   DO i = 1,klon
+     qPrls(i,it) = his_dh(i)/max(flxr(i,1)+flxs(i,1),1.e-16)
+   ENDDO
+!jyg end
+
+
+! test de conservation
+      conserv=0.
+!      DO k= klev,1,-1
+!        DO i=1, klon
+!         conserv=conserv+d_tr_insc(i,k,it)*(paprs(i,k)-paprs(i,k+1))/RG &
+!                +d_tr_bcscav(i,k,it)*(paprs(i,k)-paprs(i,k+1))/RG  &
+!                +d_tr_evap(i,k,it)*(paprs(i,k)-paprs(i,k+1))/RG
+!      if(it.eq.3) write(*,'(I2,2X,a,e20.12,2X,a,e20.12,2X,a,e20.12,2X,a,e20.12)'),&
+!      k,'lsc conserv ',conserv,'insc',d_tr_insc(i,k,it),'bc',d_tr_bcscav(i,k,it),'ev',d_tr_evap(i,k,it)
+!       ENDDO
+!     ENDDO
+
+END SUBROUTINE lsc_scav_orig
Index: LMDZ5/branches/testing/libf/phylmd/Dust/lsc_scav_spl.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/lsc_scav_spl.F90	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/lsc_scav_spl.F90	(revision 2641)
@@ -0,0 +1,302 @@
+!$Id $
+
+SUBROUTINE lsc_scav_spl(pdtime,it,iflag_lscav,oliq,flxr,flxs,rneb,beta_fisrt,  &
+                    beta_v1,pplay,paprs,t,tr_seri,d_tr_insc,          &
+                    alpha_r,alpha_s,kk, henry,     &
+                    id_prec,id_fine,id_coss, id_codu, id_scdu, &
+                    d_tr_bcscav,d_tr_evap,qPrls) 
+  USE ioipsl
+  USE dimphy
+  USE mod_grid_phy_lmdz
+  USE mod_phys_lmdz_para
+  USE traclmdz_mod
+  USE infotrac,ONLY : nbtr
+!  USE comgeomphy
+  USE iophy
+  IMPLICIT NONE 
+!=====================================================================
+! Objet : depot humide (lessivage et evaporation) de traceurs
+! Inspired by routines of Olivier Boucher (mars 1998)
+! author R. Pilon 10 octobre 2012
+! last modification 16/01/2013 (reformulation partie evaporation)
+!=====================================================================
+! SPLA version taken from trunk revision 2041
+
+  include "dimensions.h"
+  include "chem.h"
+  include "YOMCST.h"
+  include "YOECUMF.h" 
+
+  REAL,INTENT(IN)                        :: pdtime ! time step (s)
+  INTEGER,INTENT(IN)                     :: it     ! tracer number
+  INTEGER,INTENT(IN)                     :: iflag_lscav ! LS scavenging param:
+!                                             3=Reddy_Boucher2004, 4=3+RPilon.
+  REAL,DIMENSION(klon,klev+1),INTENT(IN) :: flxr     ! flux precipitant de pluie
+  REAL,DIMENSION(klon,klev+1),INTENT(IN) :: flxs     ! flux precipitant de neige
+  REAL,INTENT(IN)                        :: oliq ! contenu en eau liquide dans le nuage (kg/kg)
+  REAL,DIMENSION(klon,klev),INTENT(IN)   :: rneb
+  REAL,DIMENSION(klon,klev),INTENT(IN)   :: pplay    ! pression
+  REAL,DIMENSION(klon,klev+1),INTENT(IN) :: paprs    ! pression
+  REAL,DIMENSION(klon,klev),INTENT(IN)   :: t        ! temperature
+! tracers
+  REAL,DIMENSION(klon,klev,nbtr),INTENT(IN)   :: tr_seri        ! q de traceur  
+  REAL,DIMENSION(klon,klev),INTENT(IN)        :: beta_fisrt     ! taux de conversion de l'eau cond
+  REAL,DIMENSION(klon,klev),INTENT(OUT)       :: beta_v1        ! -- (originale version)
+  REAL,DIMENSION(klon)                        :: his_dh         ! tendance de traceur integre verticalement
+  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)  :: d_tr_insc      ! tendance du traceur 
+  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)  :: d_tr_bcscav  ! tendance de traceur
+  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)  :: d_tr_evap
+  REAL,DIMENSION(klon,nbtr),INTENT(OUT)       :: qPrls      !jyg: concentration tra dans pluie LS a la surf.
+  REAL :: dxin,dxev                              ! tendance temporaire de traceur incloud
+  REAL,DIMENSION(klon,klev) :: dxbc       ! tendance temporaire de traceur bc
+
+  INTEGER :: id_prec,id_fine,id_coss, id_codu, id_scdu
+
+!  variables locales      
+ LOGICAL,SAVE :: debut=.true.
+!$OMP THREADPRIVATE(debut)
+!
+!JE  REAL,PARAMETER :: henry=1.4  ! constante de Henry en mol/l/atm ~1.4 for gases
+  REAL,DIMENSION(nbtr) :: henry  ! constante de Henry en mol/l/atm ~1.4 for gases
+  REAL           :: henry_t    !  constante de Henry a T t  (mol/l/atm)
+!JE  REAL,PARAMETER :: kk=2900.   ! coefficient de dependence en T (K)
+  REAL,DIMENSION(nbtr) :: kk   ! coefficient de dependence en T (K)
+  REAL :: f_a     !  rapport de la phase aqueuse a la phase gazeuse
+  REAL :: beta    !  taux de conversion de l'eau en pluie
+
+  INTEGER :: i, k
+  REAL,DIMENSION(klon,klev)    :: scav  !  water liquid content / fraction aqueuse du constituant
+  REAL,DIMENSION(klon,klev)    :: zrho
+  REAL,DIMENSION(klon,klev)    :: zdz
+  REAL,DIMENSION(klon,klev)    :: zmass ! layer mass
+
+  REAL           :: frac_ev       ! cste pour la reevaporation : dropplet shrinking
+!  frac_ev = frac_gas ou frac_aer
+  REAL,PARAMETER :: frac_gas=1.0  ! cste pour la reevaporation pour les gaz
+  REAL           :: frac_aer      ! cste pour la reevaporation pour les particules
+  REAL,DIMENSION(klon,klev) :: deltaP     ! P(i+1)-P(i)
+  REAL,DIMENSION(klon,klev) :: beta_ev    !  dP/P(i+1)
+
+!  101.325  m3/l x Pa/atm
+!  R        Pa.m3/mol/K
+!   cste de dissolution pour le depot humide
+  REAL,SAVE :: frac_fine_scav
+  REAL,SAVE :: frac_coar_scav
+!$OMP THREADPRIVATE(frac_fine_scav, frac_coar_scav)
+
+! below-cloud scav variables
+! aerosol : alpha_r=0.001, gas 0.001  (Pruppacher & Klett 1967)
+!JE<<
+!  REAL,SAVE :: alpha_r  !  coefficient d'impaction pour la pluie
+!  REAL,SAVE :: alpha_s  !  coefficient d'impaction pour la neige  
+!JE>>
+  REAL, DIMENSION(nbtr) :: alpha_r  !  coefficient d'impaction pour la pluie
+  REAL, DIMENSION(nbtr) :: alpha_s  !  coefficient d'impaction pour la neige  
+  REAL,SAVE :: R_r      !  mean raindrop radius (m) 
+  REAL,SAVE :: R_s      !  mean snow crystal radius (m)
+!!! $OMP THREADPRIVATE(alpha_r, alpha_s, R_r, R_s)
+!$OMP THREADPRIVATE(R_r, R_s)
+  REAL           :: pr, ps, ice, water
+  real :: conserv
+!
+!!!!!!!!!!!!!!!!!!!! choix lessivage !!!!!!!!!!!!!!!!!!!!!!!!
+!!  logical,save  :: inscav_fisrt
+!!! $OMP THREADPRIVATE(inscav_first)
+!
+!!!!!!!!!!!!!!!!!!!!!!!!!!!
+  IF (debut) THEN
+!
+!  inscav_fisrt=.true.
+!  call getin('inscav_fisrt',inscav_fisrt)
+!  if(inscav_fisrt) then 
+!   print*,'beta from fisrtilp.F90, beta = (z_cond - z_oliq)/z_cond, inscav_fisrt=',inscav_fisrt
+!  else
+!   print*,'beta from Reddy and Bocuher 2004 (original version), inscav_fisrt=',inscav_fisrt
+!  endif
+!
+!JE      alpha_r=0.001        !  coefficient d'impaction pour la pluie
+!JE      alpha_s=0.01         !  coefficient d'impaction pour la neige  
+      R_r=0.001            !  mean raindrop radius (m) 
+      R_s=0.001            !  mean snow crystal radius (m)
+      frac_fine_scav=0.7
+      frac_coar_scav=0.7
+!     frac_aer=0.5 ~ droplet size shrinks by evap
+      frac_aer=0.5
+!
+
+!JE to speed up, commented 20140219
+!
+!      OPEN(99,file='lsc_scav_param.data',status='old', &
+!                form='formatted',err=9999)
+!      READ(99,*,end=9998)  alpha_r
+!      READ(99,*,end=9998)  alpha_s
+!      READ(99,*,end=9998)  R_r
+!      READ(99,*,end=9998)  R_s
+!      READ(99,*,end=9998)  frac_fine_scav
+!      READ(99,*,end=9998)  frac_coar_scav
+!      READ(99,*,end=9998)  frac_aer
+!9998  Continue
+!      CLOSE(99)
+!9999  Continue
+!
+!   print*,'JE alpha_r',alpha_r
+!   print*,'JE alpha_s',alpha_s
+!   print*,'JE R_r',R_r
+!   print*,'JE R_s',R_s
+!   print*,'frac_fine_scav',frac_fine_scav
+!   print*,'frac_coar_scav',frac_coar_scav
+!   print*,'frac_aer ev',frac_aer
+!
+! JE endcomment
+!
+  ENDIF !(debut)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!
+! initialization
+  dxin=0.
+  dxev=0.
+  beta_ev=0.
+
+  DO i=1,klon
+   his_dh(i)=0.
+  ENDDO
+
+  DO k=1,klev
+   DO i=1, klon 
+    dxbc(i,k)=0.
+    beta_v1(i,k)=0.
+    deltaP(i,k)=0.
+   ENDDO
+  ENDDO
+
+  DO k=1,klev
+    DO i=1, klon
+     d_tr_insc(i,k,it)=0.
+     d_tr_bcscav(i,k,it)=0.
+     d_tr_evap(i,k,it)=0.
+    ENDDO
+  ENDDO
+
+!  pressure and size of the layer
+  DO k=klev-1, 1, -1
+   DO i=1, klon 
+     zrho(i,k)=pplay(i,k)/t(i,k)/RD   
+     zdz(i,k)=(paprs(i,k)-paprs(i,k+1))/zrho(i,k)/RG
+     zmass(i,k)=(paprs(i,k)-paprs(i,k+1))/RG
+   ENDDO
+  ENDDO
+
+!JE<<
+    IF (it.eq.id_prec) THEN                               !  gas
+      frac_ev=frac_gas
+    ELSE                                   !aerosol
+      frac_ev=frac_aer
+    ENDIF
+
+    IF (it.eq.id_prec) THEN                               !  gas
+     DO k=1, klev
+      DO i=1, klon 
+       henry_t=henry(it)*exp(-kk(it)*(1./298.-1./t(i,k)))    !  mol/l/atm
+       f_a=henry_t/101.325*R*t(i,k)*oliq*zrho(i,k)/rho_water
+       scav(i,k)=f_a/(1.+f_a)
+      ENDDO 
+     ENDDO
+    ELSE                            !aerosol
+     DO k=1, klev
+      DO i=1, klon
+       scav(i,k)=frac_fine_scav
+      ENDDO
+     ENDDO
+    ENDIF
+!JE>>
+   DO k=klev-1, 1, -1
+    DO i=1, klon 
+!  incloud scavenging
+!   if(inscav_fisrt) then 
+   if (iflag_lscav .eq. 4) then
+      beta=beta_fisrt(i,k)*rneb(i,k)
+   else
+      beta=flxr(i,k)-flxr(i,k+1)+flxs(i,k)-flxs(i,k+1)
+!      beta=beta/zdz(i,k)/oliq/zrho(i,k)
+      beta=beta/zmass(i,k)/oliq
+      beta=MAX(0.,beta)
+   endif ! (iflag_lscav .eq. 4)
+   beta_v1(i,k)=beta    !! for output
+!
+      dxin=tr_seri(i,k,it)*(exp(-scav(i,k)*beta*pdtime)-1.)
+!      his_dh(i)=his_dh(i)-dxin*zrho(i,k)*zdz(i,k)/pdtime !  kg/m2/s
+      his_dh(i)=his_dh(i)-dxin*zmass(i,k)/pdtime !  kg/m2/s
+      d_tr_insc(i,k,it)=dxin
+
+!  below-cloud impaction
+    IF(it.eq.id_prec) then
+      d_tr_bcscav(i,k,it)=0.
+    ELSE
+     pr=0.5*(flxr(i,k)+flxr(i,k+1))
+     ps=0.5*(flxs(i,k)+flxs(i,k+1))
+     water=pr*alpha_r(it)/R_r/rho_water
+     ice=ps*alpha_s(it)/R_s/rho_ice
+     dxbc(i,k)=-3./4.*tr_seri(i,k,it)*pdtime*(water+ice)
+!   add tracers from below cloud scav in his_dh
+     his_dh(i)=his_dh(i)-dxbc(i,k)*zmass(i,k)/pdtime !  kg/m2/s
+     d_tr_bcscav(i,k,it)=dxbc(i,k)
+    ENDIF
+
+!  reevaporation
+      deltaP(i,k)=flxr(i,k+1)+flxs(i,k+1)-flxr(i,k)-flxs(i,k)
+      deltaP(i,k)=max(deltaP(i,k),0.)
+
+      if(flxr(i,k+1)+flxs(i,k+1).gt.1.e-16) then
+       beta_ev(i,k)=deltaP(i,k)/(flxr(i,k+1)+flxs(i,k+1))
+      else
+       beta_ev(i,k)=0.
+      endif
+
+      beta_ev(i,k)=max(min(1.,beta_ev(i,k)),0.)
+
+!jyg
+      
+      if(abs(1-(1-frac_ev)*beta_ev(i,k)).gt.1.e-16) then
+! remove tracers from precipitation owing to release by evaporation in his_dh
+!      dxev=frac_ev*beta_ev(i,k)*his_dh(i) *pdtime/(zrho(i,k)*zdz(i,k)) &
+      dxev=frac_ev*beta_ev(i,k)*his_dh(i) *pdtime/(zmass(i,k)) &
+                                      /(1 -(1-frac_ev)*beta_ev(i,k))
+       his_dh(i)=his_dh(i)*(1 - frac_ev*beta_ev(i,k) / (1 -(1-frac_ev)*beta_ev(i,k)))
+      else
+!       dxev=his_dh(i) *pdtime/(zrho(i,k)*zdz(i,k))
+       dxev=his_dh(i) *pdtime/(zmass(i,k))
+       his_dh(i)=0.
+      endif
+!      print*,  k, 'beta_ev',beta_ev
+! remove tracers from precipitation owing to release by evaporation in his_dh
+!!      dxev=frac_ev*deltaP(i,k)*pdtime * his_dh(i) /(zrho(i,k)*zdz(i,k))
+!rplmd
+!!      dxev=frac_ev*deltaP(i,k)*his_dh(i) *pdtime/(zrho(i,k)*zdz(i,k)) &
+!!                                      /max(flxr(i,k)+flxs(i,k),1.e-16)
+
+
+      d_tr_evap(i,k,it)=dxev
+!!     tendency is further added in phytrac x = x + dx
+    ENDDO !!  do i
+   ENDDO  !! do k
+
+!jyg (20130114)
+   DO i = 1,klon
+     qPrls(i,it) = his_dh(i)/max(flxr(i,1)+flxs(i,1),1.e-16)
+   ENDDO
+!jyg end
+
+
+! test de conservation
+      conserv=0.
+!      DO k= klev,1,-1
+!        DO i=1, klon
+!         conserv=conserv+d_tr_insc(i,k,it)*(paprs(i,k)-paprs(i,k+1))/RG &
+!                +d_tr_bcscav(i,k,it)*(paprs(i,k)-paprs(i,k+1))/RG  &
+!                +d_tr_evap(i,k,it)*(paprs(i,k)-paprs(i,k+1))/RG
+!      if(it.eq.3) write(*,'(I2,2X,a,e20.12,2X,a,e20.12,2X,a,e20.12,2X,a,e20.12)'),&
+!      k,'lsc conserv ',conserv,'insc',d_tr_insc(i,k,it),'bc',d_tr_bcscav(i,k,it),'ev',d_tr_evap(i,k,it)
+!       ENDDO
+!     ENDDO
+
+END SUBROUTINE lsc_scav_spl
Index: LMDZ5/branches/testing/libf/phylmd/Dust/minmaxqfi2.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/minmaxqfi2.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/minmaxqfi2.F	(revision 2641)
@@ -0,0 +1,33 @@
+      subroutine minmaxqfi2(zq,qmin,qmax,comment)
+c
+      USE dimphy
+      USE infotrac
+#include "dimensions.h"
+
+!      character*20 comment
+      character*(*) comment
+      real qmin,qmax
+      real zq(klon,klev)
+
+      integer ijmin, lmin, ijlmin
+      integer ijmax, lmax, ijlmax
+
+      integer ismin,ismax
+
+      ijlmin=ismin(klon*klev,zq,1)
+      lmin=(ijlmin-1)/klon+1
+      ijmin=ijlmin-(lmin-1)*klon
+      zqmin=zq(ijmin,lmin)
+
+      ijlmax=ismax(klon*klev,zq,1)
+      lmax=(ijlmax-1)/klon+1
+      ijmax=ijlmax-(lmax-1)*klon
+      zqmax=zq(ijmax,lmax)
+ 
+      if(zqmin.lt.qmin.or.zqmax.gt.qmax) 
+     s     write(*,9999) comment,
+     s     ijmin,lmin,zqmin,ijmax,lmax,zqmax
+
+      return
+9999  format(a20,2('  q(',i4,',',i2,')=',e12.5))
+      end
Index: LMDZ5/branches/testing/libf/phylmd/Dust/minmaxsource.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/minmaxsource.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/minmaxsource.F	(revision 2641)
@@ -0,0 +1,34 @@
+      subroutine minmaxsource(zq,qmin,qmax,comment)
+
+      USE dimphy
+      USE infotrac
+
+#include "dimensions.h"
+
+!      character*20 comment
+      character*(*) comment
+      real qmin,qmax
+      real zq(klon,nbtr)
+
+      integer ijmin, lmin, ijlmin
+      integer ijmax, lmax, ijlmax
+
+      integer ismin,ismax
+
+      ijlmin=ismin(klon*nbtr,zq,1)
+      lmin=(ijlmin-1)/klon+1
+      ijmin=ijlmin-(lmin-1)*klon
+      zqmin=zq(ijmin,lmin)
+
+      ijlmax=ismax(klon*nbtr,zq,1)
+      lmax=(ijlmax-1)/klon+1
+      ijmax=ijlmax-(lmax-1)*klon
+      zqmax=zq(ijmax,lmax)
+
+      if(zqmin.lt.qmin.or.zqmax.gt.qmax) 
+     s     write(*,9999) comment,
+     s     ijmin,lmin,zqmin,ijmax,lmax,zqmax
+
+      return
+9999  format(a20,2('  q(',i4,',',i2,')=',e12.5))
+      end
Index: LMDZ5/branches/testing/libf/phylmd/Dust/neutral.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/neutral.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/neutral.F	(revision 2641)
@@ -0,0 +1,72 @@
+c*********************************************************************** 
+	subroutine neutral(u10_mps,ustar_mps,obklen_m,
+     +         u10n_mps	)
+c-----------------------------------------------------------------------	
+c subroutine to compute u10 neutral wind speed
+c inputs
+c	u10_mps - wind speed at 10 m (m/s)
+c	ustar_mps - friction velocity (m/s)
+c	obklen_m - monin-obukhov length scale (m)
+c outputs
+c	u10n_mps - wind speed at 10 m under neutral conditions (m/s)
+c following code assumes reference height Z is 10m, consistent with use
+c of u10 and u10_neutral.  If not, code
+c should be changed so that constants of 50. and 160. in equations
+c below are changed to -5 * Z and -16 * Z respectively.
+c Reference:  G. L. Geernaert.  'Bulk parameterizations for the 
+c wind stress and heat fluxes,' in Surface Waves and Fluxes, Vol. I,
+c Current Theory, Geernaert and W.J. Plant, editors, Kluwer Academic
+c Publishers, Boston, MA, 1990.
+c subroutine written Feb 2001 by eg chapman
+c adapted to LMD-ZT by E. Cosme 310801
+c Following Will Shaw (PNL, Seattle) the theory applied for flux
+c calculation with the scheme of Nightingale et al. (2000) does not
+c hold anymore when -1<obklen<20. In this case, u10n is set to 0,
+c so that the transfer velocity  computed in nightingale.F will also
+c be 0. The flux is then set to 0.
+c----------------------------------------------------------------------		
+c
+      USE dimphy
+#include "dimensions.h"
+c
+        real u10_mps(klon),ustar_mps(klon),obklen_m(klon)
+        real u10n_mps(klon)
+        real pi,von_karman
+c       parameter (pi = 3.141592653589793, von_karman = 0.4)	
+c pour etre coherent avec vk de bl_for_dms.F
+        parameter (pi = 3.141592653589793, von_karman = 0.35)	
+c
+        real phi, phi_inv, phi_inv_sq, f1, f2, f3, dum1, psi
+        integer i
+
+
+        psi = 0.
+        do i=1,klon
+
+	if (u10_mps(i) .lt. 0.) u10_mps(i) = 0.0
+	
+	if  (obklen_m(i) .lt. 0.) then 
+		phi = (1. - 160./obklen_m(i))**(-0.25)
+		phi_inv = 1./phi
+		phi_inv_sq = 1./phi * 1./phi
+		f1 = (1. + phi_inv) / 2.
+		f2 = (1. + phi_inv_sq)/2.
+c following to avoid numerical overruns. recall tan(90deg)=infinity
+		dum1 = min (1.e24, phi_inv)
+		f3 = atan(dum1)
+		psi = 2.*log(f1) + log(f2) - 2.*f3 + pi/2.   
+	else if (obklen_m(i) .gt. 0.) then
+		psi = -50. / obklen_m(i)
+	end if
+
+	u10n_mps(i) = u10_mps(i) + (ustar_mps(i) * psi /von_karman )
+c u10n set to 0. if -1 < obklen < 20
+        if ((obklen_m(i).gt.-1.).and.(obklen_m(i).lt.20.)) then
+            u10n_mps(i) = 0.
+        endif
+	if (u10n_mps(i) .lt. 0.) u10n_mps(i) = 0.0
+
+        enddo
+	return
+	end
+c***********************************************************************
Index: LMDZ5/branches/testing/libf/phylmd/Dust/nightingale.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/nightingale.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/nightingale.F	(revision 2641)
@@ -0,0 +1,83 @@
+      SUBROUTINE nightingale(u, v, u_10m, v_10m, paprs, pplay, 
+     .                       cdragh, cdragm, t, q, ftsol, tsol, 
+     .                       pctsrf, lmt_dmsconc, lmt_dms)
+c
+      USE dimphy 
+      USE indice_sol_mod
+      IMPLICIT NONE 
+c
+#include "dimensions.h"
+#include "YOMCST.h"
+c
+      REAL u(klon,klev), v(klon,klev)
+      REAL u_10m(klon), v_10m(klon)
+      REAL ftsol(klon,nbsrf)
+      REAL tsol(klon)
+      REAL paprs(klon,klev+1), pplay(klon,klev)
+      REAL t(klon,klev)
+      REAL q(klon,klev)
+      REAL cdragh(klon), cdragm(klon)
+      REAL pctsrf(klon,nbsrf)
+      REAL lmt_dmsconc(klon)  ! concentration oceanique DMS
+      REAL lmt_dms(klon)      ! flux de DMS
+c
+      REAL ustar(klon), obklen(klon)
+      REAL u10(klon), u10n(klon)
+      REAL tvelocity, schmidt_corr
+      REAL t1, t2, t3, t4, viscosity_kin, diffusivity, schmidt
+      INTEGER i
+c
+      CALL bl_for_dms(u, v, paprs, pplay, cdragh, cdragm,
+     .                t, q, tsol, ustar, obklen)
+c
+      DO i=1,klon
+        u10(i)=SQRT(u_10m(i)**2+v_10m(i)**2)
+      ENDDO
+c
+      CALL neutral(u10, ustar, obklen, u10n)
+c
+      DO i=1,klon
+c
+c	tvelocity - transfer velocity, also known as kw (cm/s)
+c	schmidt_corr - Schmidt number correction factor (dimensionless)
+c Reference:  Nightingale, P.D., G. Malin, C. S. Law, J. J. Watson, P.S. Liss
+c  M. I. Liddicoat, J. Boutin, R.C. Upstill-Goddard. 'In situ evaluation 
+c  of air-sea gas exchange parameterizations using conservative and 
+c  volatile tracers.'  Glob. Biogeochem. Cycles, 14:373-387, 2000.
+c compute transfer velocity using u10neutral     
+c
+      tvelocity = 0.222*u10n(i)*u10n(i) + 0.333*u10n(i)
+c
+c above expression gives tvelocity in cm/hr. convert to cm/s. 1hr =3600 sec
+
+      tvelocity = tvelocity / 3600. 	
+
+c compute the correction factor, which for Nightingale parameterization is 
+c based on how different the schmidt number is from 600.   
+c correction factor based on temperature in Kelvin. good
+c only for t<=30 deg C.  for temperatures above that, set correction factor
+c equal to value at 30 deg C.
+
+      IF (ftsol(i,is_oce) .LE. 303.15) THEN
+         t1 = ftsol(i,is_oce) 
+      ELSE
+         t1 = 303.15
+      ENDIF        
+
+      t2 = t1 * t1
+      t3 = t2 * t1
+      t4 = t3 * t1
+      viscosity_kin = 3.0363e-9*t4 - 3.655198e-6*t3 + 1.65333e-3*t2 
+     +      - 3.332083e-1*t1 + 25.26819
+      diffusivity = 0.01922 * exp(-2177.1/t1)
+      schmidt = viscosity_kin / diffusivity
+      schmidt_corr = (schmidt/600.)**(-.5)          	 
+c
+      lmt_dms(i) = tvelocity  *  pctsrf(i,is_oce) 
+     .        * lmt_dmsconc(i)/1.0e12 * schmidt_corr * RNAVO
+c
+      IF (lmt_dmsconc(i).LE.1.e-20) lmt_dms(i)=0.0
+c
+      ENDDO
+c
+      END
